// essaiMain.c 
//
// main file for essai
//
// prog qui envoie une vitesse rfrence sur le port srie du palm
// a marche sur l'mulateur !
// This wizard-generated code is based on code adapted from the
// stationery files distributed as part of the Palm OS SDK 4.0.
//
// Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
// All rights reserved.

#include <PalmOS.h>
#include <StringMgr.h>

#include "essai.h"
#include "essaiRsc.h"

// ********************************************************************
// Entry Points
// ********************************************************************

// ********************************************************************
// Global variables
// ********************************************************************

int Vitesse;
unsigned short v;
Char ReferenceLabel[40];
//static MemHandle PrvTextH = NULL;  	// holds latest text
UInt16 portId;
Boolean serPortOpened;
Err err;

// g_prefs
// cache for application preferences during program execution
essaiPreferenceType g_prefs;

// ********************************************************************
// Internal Constants
// ********************************************************************

// Define the minimum OS version we support
#define ourMinVersion    sysMakeROMVersion(3,0,0,sysROMStageDevelopment,0)
#define kPalmOS10Version sysMakeROMVersion(1,0,0,sysROMStageRelease,0)

// ********************************************************************
// Internal Functions
// ********************************************************************
void UpdateAffichage();

// FUNCTION: GetObjectPtr
//
// DESCRIPTION:
//
// This routine returns a pointer to an object in the current form.
//
// PARAMETERS:
//
// formId
//     id of the form to display
//
// RETURNED:
//     address of object as a void pointer

static void * GetObjectPtr(UInt16 objectID)
{
    FormType * frmP;

    frmP = FrmGetActiveForm();
    return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

// FUNCTION: MainFormInit
//
// DESCRIPTION: This routine initializes the MainForm form.
//
// PARAMETERS:
//
// frm
//     pointer to the MainForm form.

static void MainFormInit(FormType * /*frmP*/)
{
}

// FUNCTION: MainFormDoCommand
//
// DESCRIPTION: This routine performs the menu command specified.
//
// PARAMETERS:
// 
// command
//     menu item id

static Boolean MainFormDoCommand(UInt16 command)
{
    Boolean handled = false;
    FormType * frmP;

    switch (command)
    {
    case OptionsPreferences:

        // Clear the menu status from the display
        MenuEraseStatus(0);

        // Display the PreferencesForm.
//        frmP = FrmInitForm (PreferencesForm);
//        FrmDoDialog (frmP);                    
//        FrmDeleteForm (frmP);
		FrmGotoForm(PreferencesForm);

        handled = true;
        break;
        
    case HelpAbout:

        // Clear the menu status from the display
        MenuEraseStatus(0);

        // Display the About Box.
        frmP = FrmInitForm (AboutForm);
        FrmDoDialog (frmP);                    
        FrmDeleteForm (frmP);

        handled = true;
        break;
    }
    
    return handled;
}

void UpdateAffichage()
{
FormType * frmP;
ControlType * ctlP;
//	FieldType *fldP;
UInt32 numSent;
unsigned int vit_bin;
char out[4];
	out[3]=0;	// fin de la squence
	frmP = FrmGetActiveForm();
	ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, MainVitesseRefLabel));
	StrPrintF  ( ReferenceLabel,"%d tr/mn", Vitesse);
	CtlSetLabel(ctlP, ReferenceLabel);
	FrmDrawForm( frmP);

	ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, MainBarreSliderControl));
	CtlSetSliderValues (ctlP, NULL, NULL, NULL, & v);
/*
fldP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, MainVitesseRefField));
StrPrintF  ( ReferenceLabel,"%d tr/mn", Vitesse);
if (!PrvTextH)	PrvTextH = PrvCloneStr(ReferenceLabel);
FldSetTextHandle( fldP, PrvTextH);
*/
	if (serPortOpened)	{
						//vit_bin =500*Vitesse/500.0;
						vit_bin=Vitesse;
				        out[0]='1';
				        out[1]=vit_bin & 255;
				        out[2]=vit_bin /256;
						//toSend = StrLen(out);
						numSent = SrmSend(portId, out, 4, &err);
						if (err == serErrTimeOut) {
												//cts timeout detected
												FrmAlert (Err_send_serialAlert);
												}
						}
}

// FUNCTION: MainFormHandleEvent
//
// DESCRIPTION:
//
// This routine is the event handler for the "MainForm" of this 
// application.
//
// PARAMETERS:
//
// eventP
//     a pointer to an EventType structure
//
// RETURNED:
//     true if the event was handled and should not be passed to
//     FrmHandleEvent

static Boolean MainFormHandleEvent(EventType * eventP)
{
  Boolean handled = false;
	FormType * frmP;
	ControlType * ctlP;
	UInt16 paramSize;
	UInt32 flags = 	srmSettingsFlagBitsPerChar8 |
				srmSettingsFlagParityOnM | srmSettingsFlagParityEvenM |
				srmSettingsFlagStopBits1;
				// | srmSettingsFlagRTSAutoM |	srmSettingsFlagCTSAutoM;

    switch (eventP->eType) 
        {
        case menuEvent:
            return MainFormDoCommand(eventP->data.menu.itemID);

        case frmOpenEvent:
            frmP = FrmGetActiveForm();
 			Vitesse=0;
/*
			fldP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, MainVitesseRefField));
			StrPrintF  ( ReferenceLabel,"%d tr/mn", Vitesse);
			if (!PrvTextH)	PrvTextH = PrvCloneStr(ReferenceLabel);
			FldSetTextHandle( fldP, PrvTextH);
*/	
			serPortOpened = false;
			err = SrmOpen( serPortCradlePort, 9600, &portId);
			// serPortCradlePort ou serPortCradleRS232Port ou serPortIrPort
			if (err!=errNone) 	{
								FrmAlert (Err_open_serialAlert);
								}
			//record our open status in global.
			serPortOpened = true;
			paramSize = sizeof(flags);
			err = SrmControl( portId, srmCtlSetFlags, &flags, &paramSize);
			if (err!=errNone) 	{
								FrmAlert (Err_open_serialAlert);
								}

          	MainFormInit(frmP);
            FrmDrawForm(frmP);
            handled = true;
            break;

        case frmCloseEvent:
			if (serPortOpened)	{
								err = SrmClose ( portId);
								if (err!=errNone) 	{
													FrmAlert (Err_close_serialAlert);
													}
								//record our open status in global.
								serPortOpened = false;
								}
            handled = false;
            break;

        case frmUpdateEvent:
            // To do any custom drawing here, first call 
            // FrmDrawForm(), then do your drawing, and 
            // then set handled to true.
            break;

        case keyDownEvent:
            
		switch (eventP->data.keyDown.chr)
			{
			case pageUpChr:
				v=++Vitesse+50;
				UpdateAffichage();
			    handled = true;
				break;

			case pageDownChr:
				v=--Vitesse+50;
				UpdateAffichage();
	            handled = true;
				break;
			}
            break;

		case ctlRepeatEvent:
		switch (eventP->data.ctlSelect.controlID)
			{
			case MainPlusRepeating:
				v=++Vitesse+50;
				UpdateAffichage();
	            handled = false;
				break;

			case MainMoinsRepeating:
				v=--Vitesse+50;
				UpdateAffichage();
	            handled = false;
				break;
			}

		case ctlSelectEvent:
			/* It is not necessary to have cases for multiple
			 * ctlSelectEvents, because we only have one button
			 * on the form. */
			 // ici plusieur control types !!
		switch (eventP->data.ctlSelect.controlID)
			{
			
			case MainSTOPButton:
// mise  jour de l'affichage
				Vitesse=0;
				v=50;
				UpdateAffichage();
	            handled = true;
				break;

			case MainBarreSliderControl:
        frmP = FrmGetActiveForm();
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, MainBarreSliderControl));
				CtlGetSliderValues (ctlP, NULL, NULL, NULL, & v);
				Vitesse=v-50;	
				// la Vitesse change !
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, MainVitesseRefLabel));
				StrPrintF  ( ReferenceLabel,"%d tr/mn", Vitesse);
				CtlSetLabel(ctlP, ReferenceLabel);
				FrmDrawForm( frmP);
	            handled = true;
				break;
			}
        default:
            break;
        }
    
    return handled;
}

// Lotfi was here :-)
static Boolean PreferencesFormHandleEvent(EventType * eventP)
{
    Boolean handled = false;
    FormType * frmP;
	ControlType * ctlP;
	unsigned short v;
				
    switch (eventP->eType) 
        {

        case frmOpenEvent:
            frmP = FrmGetActiveForm();

            FrmDrawForm(frmP);
            handled = true;
            break;
            
        case frmUpdateEvent:
            // To do any custom drawing here, first call 
            // FrmDrawForm(), then do your drawing, and 
            // then set handled to true.
            break;
            
		case ctlSelectEvent:
			/* It is not necessary to have cases for multiple
			 * ctlSelectEvents, because we only have one button
			 * on the form. */
			 // ici plusieur control types !!
		switch (eventP->data.ctlSelect.controlID)
			{
			case PreferencesBarreSliderControl:
// mise  jour de l'affichage

	            frmP = FrmGetActiveForm();
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, PreferencesBarreSliderControl));
				CtlGetSliderValues (ctlP, NULL, NULL, NULL, & v);
				Vitesse=v;	
				// la Vitesse change !
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, PreferencesVitesseRefLabel));
				StrPrintF  ( ReferenceLabel,"%d tr/mn", v);
				CtlSetLabel(ctlP, ReferenceLabel);
				FrmDrawForm( frmP);
	            handled = true;
				break;

			case PreferencesPlusButton:
// mise  jour de l'affichage
				v=++Vitesse;
				frmP = FrmGetActiveForm();
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, PreferencesVitesseRefLabel));
				StrPrintF  ( ReferenceLabel,"%d tr/mn", v);
				CtlSetLabel(ctlP, ReferenceLabel);

/*
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, PreferencesReferenceLabel));
				StrCopy( ReferenceLabel, CtlGetLabel(ctlP));
				StrCopy( ReferenceLabel, "azz");
				CtlSetLabel(ctlP, ReferenceLabel);
*/
				
				FrmDrawForm( frmP);

				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, PreferencesBarreSliderControl));
				CtlSetSliderValues (ctlP, NULL, NULL, NULL, & v);
	            handled = true;
				break;

			case PreferencesMoinsButton:
				v=--Vitesse;
				frmP = FrmGetActiveForm();
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, PreferencesVitesseRefLabel));
				StrPrintF  ( ReferenceLabel,"%d tr/mn", v);
				CtlSetLabel(ctlP, ReferenceLabel);
				ctlP=FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP, PreferencesBarreSliderControl));
				CtlSetSliderValues (ctlP, NULL, NULL, NULL, & v);
				FrmDrawForm( frmP);
	            handled = true;
				break;
				
			case PreferencesOkButton:
				FrmGotoForm(MainForm);			
				handled = true;
				break;
				
			}
			
        default:
            break;
        }
    
    return handled;
}

// FUNCTION: AppHandleEvent
//
// DESCRIPTION: 
//
// This routine loads form resources and set the event handler for
// the form loaded.
//
// PARAMETERS:
//
// event
//     a pointer to an EventType structure
//
// RETURNED:
//     true if the event was handled and should not be passed
//     to a higher level handler.

static Boolean AppHandleEvent(EventType * eventP)
{
    UInt16 formId;
    FormType * frmP;

    if (eventP->eType == frmLoadEvent)
    {
        // Load the form resource.
        formId = eventP->data.frmLoad.formID;
        frmP = FrmInitForm(formId);
        FrmSetActiveForm(frmP);

        // Set the event handler for the form.  The handler of the 
        // currently active form is called by FrmHandleEvent each 
        // time is receives an event.
        switch (formId)
        {
        case MainForm:
            FrmSetEventHandler(frmP, MainFormHandleEvent);
            break;

		case PreferencesForm:
			FrmSetEventHandler (frmP, PreferencesFormHandleEvent);
			break;
			
        default:
            break;
        }
        return true;
    }

    return false;
}

// FUNCTION: AppEventLoop
//
// DESCRIPTION: This routine is the event loop for the application.

static void AppEventLoop(void)
{
    UInt16 error;
    EventType event;

    do {
        // change timeout if you need periodic nilEvents
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            if (! MenuHandleEvent(0, &event, &error))
            {
                if (! AppHandleEvent(&event))
                {
                    FrmDispatchEvent(&event);
                }
            }
        }
    } while (event.eType != appStopEvent);
}

// FUNCTION: AppStart
//
// DESCRIPTION:  Get the current application's preferences.
//
// RETURNED:
//     errNone - if nothing went wrong

static Err AppStart(void)
{
    UInt16 prefsSize;

    // Read the saved preferences / saved-state information.
    prefsSize = sizeof(essaiPreferenceType);
    if (PrefGetAppPreferences(
        appFileCreator, appPrefID, &g_prefs, &prefsSize, true) != 
        noPreferenceFound)
    {
        // FIXME: setup g_prefs with default values
    }
    
    return errNone;
}

// FUNCTION: AppStop
//
// DESCRIPTION: Save the current state of the application.

static void AppStop(void)
{
    // Write the saved preferences / saved-state information.  This 
    // data will be saved during a HotSync backup.
    PrefSetAppPreferences(
        appFileCreator, appPrefID, appPrefVersionNum, 
        &g_prefs, sizeof(essaiPreferenceType), true);
        
    // Close all the open forms.
    FrmCloseAllForms();
}

// all code from here to end of file should use no global variables
#pragma warn_a5_access on

// FUNCTION: RomVersionCompatible
//
// DESCRIPTION: 
//
// This routine checks that a ROM version is meet your minimum 
// requirement.
//
// PARAMETERS:
//
// requiredVersion
//     minimum rom version required
//     (see sysFtrNumROMVersion in SystemMgr.h for format)
//
// launchFlags
//     flags that indicate if the application UI is initialized
//     These flags are one of the parameters to your app's PilotMain
//
// RETURNED:
//     error code or zero if ROM version is compatible

static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
    UInt32 romVersion;

    // See if we're on in minimum required version of the ROM or later.
    FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
    if (romVersion < requiredVersion)
    {
        if ((launchFlags & 
            (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
            (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
        {
            FrmAlert (RomIncompatibleAlert);

            // Palm OS 1.0 will continuously relaunch this app unless 
            // we switch to another safe one.
            if (romVersion <= kPalmOS10Version)
            {
                AppLaunchWithCommand(
                    sysFileCDefaultApp, 
                    sysAppLaunchCmdNormalLaunch, NULL);
            }
        }

        return sysErrRomIncompatible;
    }

    return errNone;
}

// FUNCTION: essaiPalmMain
//
// DESCRIPTION: This is the main entry point for the application.
//
// PARAMETERS:
//
// cmd
//     word value specifying the launch code. 
//
// cmdPB
//     pointer to a structure that is associated with the launch code
//
// launchFlags
//     word value providing extra information about the launch
//
// RETURNED:
//     Result of launch, errNone if all went OK

static UInt32 essaiPalmMain(
    UInt16 cmd, 
    MemPtr /*cmdPBP*/, 
    UInt16 launchFlags)
{
    Err error;

    error = RomVersionCompatible (ourMinVersion, launchFlags);
    if (error) return (error);

    switch (cmd)
    {
    case sysAppLaunchCmdNormalLaunch:
        error = AppStart();
        if (error) 
            return error;

        // start application by opening the main form
        // and then entering the main event loop
        FrmGotoForm(MainForm);
        AppEventLoop();
        
        AppStop();
        break;

    default:
        break;
    }

    return errNone;
}

// FUNCTION: PilotMain
//
// DESCRIPTION: This is the main entry point for the application.
// 
// PARAMETERS:
//
// cmd
//     word value specifying the launch code. 
//
// cmdPB
//     pointer to a structure that is associated with the launch code
//
// launchFlags
//     word value providing extra information about the launch.
//
// RETURNED:
//     Result of launch, errNone if all went OK

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    return essaiPalmMain(cmd, cmdPBP, launchFlags);
}

// turn a5 warning off to prevent it being set off by C++
// static initializer code generation
#pragma warn_a5_access reset
